/* makElev.cc
-----------------------------------
 饹 MakeElev μ¸
-----------------------------------
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>

#include "makElev.h"            /* 饹 MakeElev  */

// դ󥹥ȥ饯
MakeElev :: MakeElev(int X_ori, int Y_ori, int X_opp, int Y_opp)
{
  int i, j;

  X_origin = X_ori;
  Y_origin = Y_ori;
  X_opposite = X_opp;
  Y_opposite = Y_opp;

  // γ
  num_x = (X_opposite - X_origin)*120;
  grid_elev = new int*[num_x];

  num_y = (Y_opposite - Y_origin)*120;
  for(i=0; i<num_x; i++){
    grid_elev[i] = new int[num_y];
  }

  // ν
  for(i = 0; i < num_x; i++){
    for(j = 0; j < num_y; j++){
      grid_elev[i][j] = -1111;
    }
  }
  printf("i = %d  j = %d\n", i, j);
}

// ǥȥ饯
MakeElev :: ~MakeElev(void)
{
  for(int i=0; i<num_x; i++){
    delete [] grid_elev[i];
  }
  delete [] grid_elev;
}


void MakeElev::Set_grid_elevation
(char* df_name, int x_origin, int y_origin)
{
  FILE* fp_tmp;
  FILE* fp_d;
  int i, j;
  int i_min, i_max, j_min, j_max;          /* i, j κ硦Ǿ */
  int h1;                                  /* ɸǡβΰ̤ */
  int h2;                                  /* ɸǡξΰ̤ */
  int elevation;                           /* ɸ(m) */

  i_min = (x_origin - X_origin)*120;
  i_max = i_min + 119;
//  printf("i_min = %d\n", 
  j_min = (y_origin - Y_origin)*120;
  j_max = j_min + 119;

  i = i_min;
  j = j_max;

  fp_tmp = fopen("temp.dat", "w");

  if((fp_d = fopen(df_name, "rb")) == NULL){
    printf("Set_grid_elevation\n");
    printf("Cannot open '%s'. \n", df_name);
    exit(1);
  }

//  printf("%s\n", df_name);

  while ((h1 = fgetc(fp_d)) != EOF) {    
    h2 = fgetc(fp_d);
    elevation = h2*256 + h1;

    grid_elev[i][j] = elevation;
      fprintf(fp_tmp, "grid_elev[%d][%d] = %d\n", i, j, grid_elev[i][j]);

    if (i == i_max) {
      if(j == j_min){
	break;
      }
      else{
	i = i_min; j--;
      }
    } 
    else i++;
  }
//  printf("%s : i = %d, j = %d\n", df_name, i, j);
  fclose(fp_d);
  fclose(fp_tmp);
}


void MakeElev::Make_channel_elevation(char* cf_name, char* of_name)
{
  FILE* fp_c;
  FILE* fp_o;
  char buf[256];
  int info, n, t1, t2, t3, t4, t5;
  double w, Z;
  int i, j;
  double grid_x, grid_y;
  double x, y;                         /* ޷ */
  int z;                               /* ɸ */
  long ix, iy;                         /* long int ľ޷ */

  if((fp_c = fopen(cf_name, "r")) == NULL){
    printf("Make_channel_elevation\n");
    printf("Cannot open input file. \n");
    exit(1);
  }

  else if((fp_o = fopen(of_name, "w")) == NULL){
    printf("Make_channel_elevation\n");
    printf("Cannot open output file(1). \n");
    exit(1);
  }

  fprintf(fp_o, "# added elevation value from GLOBE data\n#\n");

  while (fgets(buf, 256, fp_c) != NULL) {
    if(strcmp(buf, "[Data of End Points]\n") == 0){
      fprintf(fp_o, "%s", buf);
      while(1){
		fgets(buf, 256, fp_c);
		if(strcmp(buf, "[Number of River Segments]\n") == 0){
	  	fprintf(fp_o, "%s", buf);
	  	break;
	}
	else if((sscanf(buf, "%d %lf %lf %lf %d",
		   &n, &x, &y, &Z, &info)) == 5){
	  // оݤȤƻ޳Գˤɸͤ -9999 Ȥ롣
	  if ((x < X_origin)||(x > X_opposite)
	      ||(y < Y_origin)||(y > Y_opposite)){
	    
	    // ޷ٺɸ(ñ̤ϡ١) 1000000 ܤʲ
	    // ڼΤơlong int ˤ롣
	    x = 1000000*x;
	    y = 1000000*y;
	    ix = (long)floor(x);
	    iy = (long)floor(y);
	    z = -9999;
	    fprintf(fp_o, "%d %f %f %d 0\n",
		    n, x*pow(10,-6), y*pow(10,-6), z, info);
	  }
	
	  else{
	    grid_x = (x - X_origin)*120;
	    grid_y = (y - Y_origin)*120;
	    
	    // grid_x, grid_y ξʲڤΤƤ롣
	    i = (int)floor(grid_x);
	    j = (int)floor(grid_y);
	    
	    // ޷ٺɸ(ñ̤ϡ١) 1000000 ܤʲ
	    // ڼΤơlong ˤ롣	  
	    x = 1000000*x;
	    y = 1000000*y;
	    ix = (long)floor(x);
	    iy = (long)floor(y);
	    z = grid_elev[i][j];
//	    printf("z = %d\n", z);
	    fprintf(fp_o, "%d %f %f %d 0\n",
		    n, x*pow(10,-6), y*pow(10,-6), z, info);
	    
	  }	  
	}
      }
    }
    else if(strcmp(buf, "[Data]\n") == 0){
      fprintf(fp_o, "%s", buf);
      while(fgets(buf, 256, fp_c) != NULL){
	if((sscanf(buf, "%d %d %d %d %d %lf %lf %d %lf\n",
		   &t1, &t2, &t3, &t4, &t5, &x, &y, &z, &w)) == 9){
	  // оݤȤƻ޳Գˤɸͤ -9999 Ȥ롣
	  if ((x < X_origin)||(x > X_opposite)
	      ||(y < Y_origin)||(y > Y_opposite)){
	    
	    // ޷ٺɸ(ñ̤ϡ١) 1000000 ܤʲ
	    // ڼΤơlong int ˤ롣
	    x = 1000000*x;
	    y = 1000000*y;
	    ix = (long)floor(x);
	    iy = (long)floor(y);
	    z = -9999;
	    fprintf(fp_o, "%d %d %d %d %d %f %f %d %f\n",
		    t1, t2, t3, t4, t5, x*pow(10,-6), y*pow(10,-6), z, w);
	  }
	  else{
	    grid_x = (x - X_origin)*120;
	    grid_y = (y - Y_origin)*120;
	    
	    // grid_x, grid_y ξʲڤΤƤ롣
	    i = (int)floor(grid_x);
	    j = (int)floor(grid_y);
	    
	    // ޷ٺɸ(ñ̤ϡ١) 1000000 ܤʲ
	    // ڼΤơlong ˤ롣	  
	    x = 1000000*x;
	    y = 1000000*y;
	    ix = (long)floor(x);
	    iy = (long)floor(y);
	    z = grid_elev[i][j];

	    fprintf(fp_o, "%d %d %d %d %d %f %f %d %f\n",
		    t1, t2, t3, t4, t5, x*pow(10,-6), y*pow(10,-6), z, w);
	  }	  
	}
      }
    }
    else fprintf(fp_o, "%s", buf);
  }
  fclose(fp_c);
  fclose(fp_o);
}
